/**
 * ------------------------------------------------------------------------
 * JA Image Hotspot Module for Joomla 2.5 & 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */
 
function is_touch_device() { 
	try {
		document.createEvent("TouchEvent");
		if (jQuery(window).width() >= 768)
			return false;
		return true;
	} catch (e) {
		return false;
	}
}
function is_landscape() {
	return (jQuery(window).width() > jQuery(window).height());
}

function jaGetData(data, refpoint) {
	jQuery.ajax({
	  method: 'POST',
	  cache: false,
	  url: rootURL+'index.php?option=com_ajax&module=jaimagehotspot&format=raw&method=getcontent&Itemid='+menuID,
	  data: data
	})
	.success(function( msg ) {
		var _japopover = refpoint.next();
		_japopover.find('.popover-content').html(msg);
		_japopover.find('.popover-content').find('*').load(function(){
			calcsize(refpoint);
		});
		if (_japopover.find('.jashowvideo').length) { // if we find out this is video type pop.
			_japopover.find('.popover-content').css('margin-top', '15px');
			_japopover.find('.jashowvideo').off().unbind().bind('click touchend', function() {
				var maxwith = 'width:500px;max-width:500px;'; // default is 400 + 100 extra padding.
				if (data.content_type == 'video')
					var maxwith = 'width:'+(parseInt(data.vwidth))+'px;max-width:'+(parseInt(data.vwidth))+'px;height:'+(parseInt(data.vheight))+'px;';
				if (is_touch_device()) {
					maxwith = 'width:280px;max-width:280px;height:auto;top:10px;left:0;z-index:100000;position:fixed;';
				} else {
					$left = (refpoint.position().left - (_japopover.outerWidth()/2) + refpoint.width()/3);
					if ($left + (parseInt(data.vheight)) > jQuery(window).width())
						$left = refpoint.parents('.jai-map-wrap').width()-(parseInt(data.vheight));
					maxwith += 'top:'+(refpoint.position().top - _japopover.outerHeight() + refpoint.height()/2)+'px;left:'+($left)+'px;';
				}
				_japopover.removeClass('in').addClass('out').hide();
				_japopover.after('<div class="japopover japopmedia touchdv '+refpoint.data('bgcolor')+' popover fade in" style="'+maxwith+'display: block;">'+
				'<span class="popover-close"> <i class="fa fa-remove"></i> </span>'+
				'<div class="popover-content">'+jQuery(this).data('ifr')+'</div>'+
				'</div>');
				_japopover.next().find('.popover-close').off().unbind().bind('click touchend', function(){
					jQuery(this).parent('.japopover').remove();
					jQuery('.japopwarper').fadeOut(hideDelay);
				});
				if (is_touch_device()) calcsize(_japopover);
			});
		}
		setTimeout(function(){calcsize(refpoint);}, 600);
	})
	.error(function(XMLHttpRequest, textStatus, errorThrown) {
		console.log(textStatus);
	});
}

function touchdevice(data, refpoint) {
	var rootURL = window.location.origin?window.location.origin+'/':window.location.protocol+'/'+window.location.host+'/';
	jQuery(refpoint).parents('.jai-map-container').find('.japopwarper').fadeIn(400);
	if (!refpoint.next('.japopover').length) {
		var maxwith='';
		var mw = 300;
		if (is_landscape()) {
			mw = 400;
		}
		if (data.content_type == 'social' && data.content_url.search('twitter.com') !== -1) maxwith = 'width:'+mw+'px;max-width:'+mw+'px;'; // set max width to bigger if twitter.
		else if (data.content_type == 'social' && data.content_url.search('facebook.com') !== -1)
			maxwith = 'width:'+mw+'px;max-width:'+mw+'px;';// set max width to bigger if facebook.
		else maxwith = 'width:280px;max-width:280px;'; // default for all another type.
		maxwith += 'height:auto;top:10px;left:0;z-index:100000;position:fixed;';
		var defaultcontent='';
		if (data.content_type == 'default' || data.content_type == undefined) {
			defaultcontent = '<div class="janone_layout">'+
			(data.link != '' ? '<a href="'+data.link+'">' : '')+
				(data.content_img != '' ? '<img width="100%" src="'+rootURL+data.content_img+'" />' : '')+
				(data.details != '' ? data.details : '')+
			(data.link != '' ? '</a>' : '')+
			'</div>';
		}
		refpoint.after('<div class="japopover touchdv popover '+refpoint.data('bgcolor')+' fade top in" style="top: auto;'+maxwith+'display: block;opacity:0;visibility:hidden;">'+
		'<span class="popover-close"> <i class="fa fa-remove"></i> </span>'+
		(data.title.trim() != '' && (data.content_type == 'default' || data.content_type == undefined) ? '<h3 class="popover-title">'+data.title+'</h3>' : '')+
		'<div class="popover-content">'+(defaultcontent!='' ? defaultcontent : '<p style="text-align:center;margin:0;"><img style="margin:0 auto;width:20px;max-width:20px;" src="'+rootURL+'/modules/mod_jaimagehotspot/assets/images/loader.gif" style="width:auto;" /></p>')+'</div>'+
		'</div>');
		refpoint.next('.japopover').addClass('in');
		setTimeout(function(){
			calcsize(refpoint);
			if (data.content_type != 'default' && data.content_type != undefined) jaGetData(data, refpoint);
		}, 200);
		refpoint.next('.japopover').find('.popover-close').off().unbind().bind('click touchend', function(){
			jQuery('.japopwarper').fadeOut(hideDelay);
			jQuery(this).parent('.japopover').removeClass('in').addClass('out').fadeOut(100);
		});
	} else {
		refpoint.next('.japopover').removeClass('out').addClass('in').show();
		calcsize(refpoint);
		if (is_touch_device() && data.content_type == 'social' && data.content_url.search('facebook.com') !== -1) {
			data.fbw = jQuery(window).width();
			src = _japopover.find('iframe').attr('src');
			_japopover.find('iframe').attr('src', src.replace(/\&width\=[0-9]+/, '&width='+(jQuery(window).width()-30))).attr('width', (jQuery(window).width()-30));
		}
	}
	jQuery(refpoint).parents('.jai-map-container').find('.japopwarper').off().unbind().bind('click touchend', function(){
		jQuery(this).fadeOut(hideDelay);
		refpoint.next('.japopover').removeClass('in').addClass('out').fadeOut(100);
		jQuery('.japopmedia').remove();
	});
}

function desktopdevice(data, refpoint) {
	if (!refpoint.next('.japopover').length) {
		var maxwith = '';
		if (data.content_type == 'social' && data.content_url.search('twitter.com') !== -1) var maxwith = 'width:400px;max-width:400px;'; // set max width to bigger if twitter.
		else if (data.content_type == 'social' && data.content_url.search('facebook.com') !== -1)
			var maxwith = 'width:370px;max-width:370px;';// set max width to bigger if facebook.
		else var maxwith = 'width:280px;max-width:280px;'; // default for all another type.
		var defaultcontent='';
		if (data.content_type == 'default' || data.content_type == undefined) {
			defaultcontent = '<div class="janone_layout">'+
			(data.link != '' ? '<a href="'+data.link+'">' : '')+
				(data.content_img != '' ? '<img width="100%" src="'+rootURL+data.content_img+'" />' : '')+
				(data.details != '' ? data.details : '')+
			(data.link != '' ? '</a>' : '')+
			'</div>';
		}
		
		refpoint.after('<div class="japopover popover '+refpoint.data('bgcolor')+' fade top in" style="top: auto;'+maxwith+'display: block;opacity:0;visibility:hidden;">'+
		'<div class="arrow"></div>'+
		(data.title.trim() != '' && (data.content_type == 'default' || data.content_type == undefined) ? '<h3 class="popover-title">'+data.title+'</h3>' : '')+
		'<div class="popover-content">'+(defaultcontent!='' ? defaultcontent : '<p style="text-align:center;margin:0;"><img style="margin:0 auto;width:40px;max-width:40px;" src="'+rootURL+'/modules/mod_jaimagehotspot/assets/images/loader.gif" style="width:auto;" /></p>')+'</div>'+
		'</div>');
		refpoint.next('.japopover').addClass('in');
		setTimeout(function(){
			calcsize(refpoint);
			if (data.content_type != 'default' && data.content_type != undefined) jaGetData(data, refpoint);
		}, 200);
		refpoint.next('.japopover').off().unbind().hover(function(){
			jQuery(this).removeClass('out').addClass('in').show();
		}, function(){
			jQuery(this).removeClass('in').addClass('out').fadeOut(hideDelay);
		});
	} else {
		refpoint.next('.japopover').removeClass('out').addClass('in').show();
		calcsize(refpoint);
	}
}

function layoutPop(data, refpoint) {
	if (is_touch_device()) {
		touchdevice(data, refpoint);
	} else {
		desktopdevice(data, refpoint);
	}
}

function calcsize(refpoint) {
	_japopover = refpoint.next();
	_japopover.css('opacity', 1).css('visibility', 'visible');
	if (!_japopover.hasClass('touchdv')) {
		//desktop
		_japopover.css('bottom', (refpoint.parent('.jai-map-container').height() - refpoint.position().top)+'px');
		_japopover.css('left', ( (refpoint.position().left) - (_japopover.outerWidth(true)/2) + (refpoint.outerWidth(true)/2 ))+'px');
		_japopover.find('.arrow').css('margin-left', '-10px').css('left', '50%');
		if (refpoint.offset().left < _japopover.width()/2) {
			_japopover.css('left', refpoint.position().left+'px');
			_japopover.find('.arrow').css('margin-left', '').css('left', '13px');
		}

		if ((refpoint.offset().left + _japopover.width()/2) > jQuery(window).width()-20) { // 20 extra scroll.
			_japopover.css('left', ( (refpoint.position().left) - (_japopover.outerWidth(true)) + (refpoint.outerWidth(true) ))+'px');
			_japopover.find('.arrow').css('margin-left', '').css('left', (_japopover.outerWidth(true)-13)+'px');
		}
	} else {
		// mobile
		_japopover.css('top', (jQuery(window).height() - _japopover.height()) / 2);
		_japopover.css('left', (jQuery(window).width() - _japopover.width()) / 2);
		if (_japopover.height() > jQuery(window).height()) {
			_japopover.css('top', '10px');
		}
		_url = _japopover.find('iframe').attr('src');
		if (_url != undefined) {
			if (_url.search('facebook.com') !== -1) {
				_japopover.find('.jasocial_layout').css('overflow', 'hidden').css('width', '100%'); // fix for facebook autoresize.
			}
		}
		
		if (_japopover.find('.jasocial_layout').length) { // if social layout.
			var mw = 300;
			if (is_landscape()) {
				mw = 400;
			}
			_japopover.css('width', mw+'px').css('max-width', mw+'px');
			// recalculate.
			_japopover.css('top', (jQuery(window).height() - _japopover.height()) / 2);
			_japopover.css('left', (jQuery(window).width() - _japopover.width()) / 2);
		}
		_twitter = _japopover.find('.jasocial_layout').find('twitterwidget');
		if (_twitter.length) {
			setTimeout(function(){calcsize(refpoint);}, 400); // recalculate with twitter in case the prev function do not calculate.
		}
		// fix for web layout in landscape view.
		if (_japopover.find('.jawb_layout').length) {
			_japopover.css('height', 'auto');
			if (jQuery(window).width() > jQuery(window).height() && _japopover.height() > jQuery(window).height()) {
				_japopover.css('height', (jQuery(window).height()+10)+'px');
				_japopover.css('overflow', 'scroll');
			} else {
				// recalculate.
				_japopover.css('top', (jQuery(window).height() - _japopover.height()) / 2);
				_japopover.css('left', (jQuery(window).width() - _japopover.width()) / 2);
			}
		}
	}
}

jQuery(document).ready(function(){
	if (!jQuery('.japopwarper').length) {
		jQuery('.jai-map-container').append('<div class="japopwarper"></div>');
	}
// 	jQuery(window).resize(function(){
// 		jQuery('.jai-map-container').find('.popover.in').each(function(){
// 			calcsize(jQuery(this).prev());
// 		});
// 	});
});